/*
 * Copyright (c) 1996 The Regents of the University of California.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 * 	This product includes software developed by the Network Research
 * 	Group at Lawrence Berkeley National Laboratory.
 * 4. Neither the name of the University nor of the Laboratory may be used
 *    to endorse or promote products derived from this software without
 *    specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * @(#) $Header: load_stat.h,v 1.2 96/02/05 16:02:05 mccanne Exp $ (LBL)
 */

#include <sys/types.h>
#include "sys-time.h"

class LoadStats {
	timeval	start_decode_;
	timeval start_render_;
	timeval done_render_;
public:
	inline void sd(const timeval& t) { start_decode_ = t; }
	inline void sr(const timeval& t) { start_render_ = t; }
	inline void dr(const timeval& t) { done_render_ = t;
#ifdef DEBUGLOAD
		printf("[%ld.%ld],[%ld.%ld],[%ld.%ld]\n",
			start_decode_.tv_sec,
			start_decode_.tv_usec,
			start_render_.tv_sec,
			start_render_.tv_usec,
			done_render_.tv_sec,
			done_render_.tv_usec
		);
#endif
	}
	inline LoadStats() {
		memset(&start_decode_, 0, sizeof(timeval));
		memset(&start_render_, 0, sizeof(timeval));
		memset(&done_render_, 0, sizeof(timeval));
	}
};
