#
# Copyright (c) 1993-1994 The Regents of the University of California.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
# 3. All advertising materials mentioning features or use of this software
#    must display the following acknowledgement:
#	This product includes software developed by the University of
#	California, Berkeley and the Network Research Group at
#	Lawrence Berkeley Laboratory.
# 4. Neither the name of the University nor of the Laboratory may be used
#    to endorse or promote products derived from this software without
#    specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# @(#) $Header: vic.mak,v 1.2 96/02/05 16:07:52 mccanne Exp $ (LBL)
#
APPVER=4.0

!include <win32.mak>

ALL = vic h261_play histtolut
all:	$(ALL)

.SUFFIXES : .cc

.cc.obj:
	$(cc) $(cdebug) $(cflags) $(cvars) $(CFLAGS) -o $@ -FR$*.sbr -Tp $<

.c.obj:
	$(cc) $(cdebug) $(cflags) $(cvars) $(CFLAGS) -o $@ -FR$*.sbr $<

ED_YBITS = 4

INCLUDE_TK = -I/tcl/include
INCLUDE_TCL = 
INCLUDE_X11 = 
INCLUDE_MISC = 

LIB_TK = ../tk4.1a2/win/tk41.lib
LIB_TCL = ../tcl7.5a2/win/tcl75.lib

MKDEP = ./mkdep

BSC32= bscmake
BSC32_FLAGS=/nologo /n

LIBRARY_TK = /tcl/lib\tk4.1
TK_LIBRARY_FILES = \
		$(LIBRARY_TK)/tk.tcl \
		$(LIBRARY_TK)/button.tcl \
		$(LIBRARY_TK)/dialog.tcl \
		$(LIBRARY_TK)/entry.tcl \
		$(LIBRARY_TK)/focus.tcl \
		$(LIBRARY_TK)/listbox.tcl \
		$(LIBRARY_TK)/menu.tcl \
		$(LIBRARY_TK)/optMenu.tcl \
		$(LIBRARY_TK)/palette.tcl \
		$(LIBRARY_TK)/scale.tcl \
		$(LIBRARY_TK)/scrlbar.tcl \
		$(LIBRARY_TK)/tearoff.tcl \
		$(LIBRARY_TK)/text.tcl

LIB_GRABBER = 
INCLUDE_GRABBER = 
OBJ_GRABBER = 
SRC_GRABBER = $(OBJ_GRABBER:.o=.cc) 
OBJ_XIL = 
LIBS = $(LIB_GRABBER) $(LIB_TK) $(LIB_TCL) $(guilibs) wsock32.lib
INCLUDES = $(INCLUDE_MISC) $(INCLUDE_GRABBER) $(INCLUDE_TK) $(INCLUDE_TCL) \
	$(INCLUDE_X11) $(MD_INC) -I./jpeg -I./p64 -I.
DEFINE = -DED_YBITS=$(ED_YBITS) -DSIGRET=void -DSIGARGS=int
BFLAGS = -D_Windows -DWIN32_LEAN_AND_MEAN $(DEFINE) $(INCLUDES)
CFLAGS = $(CCOPT) $(BFLAGS)

#
# Remember to add a dependency if you add any tcl sources here.
#
TCL_VIC = ui-ctrlmenu.tcl ui-main.tcl ui-resource.tcl \
	ui-srclist.tcl ui-stats.tcl ui-util.tcl ui-windows.tcl \
	ui-switcher.tcl ui-extout.tcl ui-grabber.tcl ui-win32.tcl \
	cf-main.tcl cf-tm.tcl cf-confbus.tcl cf-network.tcl cf-util.tcl \
	tkerror.tcl entry.tcl
TCL_LIB = tk.tcl

#
# These modules are broken in libg++.  Rather than fix libg++
# every time I install it on a given system, just make them
# here (these sources came from tcl's compat directory)
#
BROKEN_OBJ = strtol.obj strtoul.obj
BLT_OBJS = bltList.obj bltTable.obj bltUtil.obj
#COLOR_OBJS = color-win32.obj
COLOR_OBJS = color-true.obj color-pseudo.obj color-dither.obj color-ed.obj \
	color-quant.obj color-gray.obj color-mono.obj color-hist.obj

OBJ0 =	getopt.obj win32.obj win32X.obj
OBJ1 =	inet.obj cellb_tables.obj tkStripchart.obj md5c.obj random.obj
OBJ2 =	main.obj net.obj net-ip.obj source.obj \
	iohandler.obj timer.obj idlecallback.obj media-timer.obj \
	session.obj session-rtpv1.obj session-nv.obj session-ivs.obj \
	decoder.obj decoder-jpeg.obj decoder-nv.obj \
	decoder-h261.obj decoder-h261v1.obj \
	decoder-cellb.obj \
	device.obj grabber.obj vw.obj Tcl.obj Tcl2.obj module.obj transmitter.obj \
	encoder-nv.obj encoder-cellb.obj encoder-h261.obj \
	transcoder-jpeg.obj framer-jpeg.obj \
	group-ipc.obj confbus.obj renderer.obj renderer-window.obj \
	color.obj $(COLOR_OBJS) \
	rgb-converter.obj jpeg.obj p64.obj dct.obj \
	compositor.obj rate-variable.obj crypt.obj crypt-dull.obj \
	grabber-still.obj $(BLT_OBJS)
OBJ3 =	cm0.obj cm1.obj huffcode.obj version.obj bv.obj \
	$(TCL_VIC:.tcl=.obj) $(TCL_LIB:.tcl=.obj)
SRC =	$(OBJ1:.obj=.c) $(OBJ2:.obj=.cc) $(BROKEN_OBJ:.obj=.c) \
	$(RTIP_OBJ:.obj=.c) $(SRC_GRABBER) $(OBJ_XIL:.obj=.cc)
OBJ =	$(OBJ0) $(OBJ1) $(OBJ2) $(OBJ3) $(BROKEN_OBJ) $(RTIP_OBJ)

SBR =	$(OBJ:.obj=.sbr) $(OBJ_GRABBER:.obj=.sbr)

OBJ_VDD = $(OBJ0) vdd.obj p64.obj p64dump.obj \
	module.obj renderer.obj renderer-window.obj color.obj \
	$(COLOR_OBJS) \
	Tcl.obj Tcl2.obj vw.obj cm0.obj cm1.obj \
	dct.obj huffcode.obj bv.obj iohandler.obj timer.obj \
	ui-vdd.obj $(TCL_LIB:.tcl=.obj)

SBR_VDD = $(OBJ_VDD:.obj=.sbr)

OBJ_H261PLAY = $(OBJ0) h261_play.obj p64.obj p64dump.obj \
	module.obj renderer.obj renderer-window.obj color.obj \
	$(COLOR_OBJS) \
	Tcl.obj Tcl2.obj vw.obj cm0.obj cm1.obj \
	dct.obj huffcode.obj bv.obj iohandler.obj random.obj timer.obj \
	ui-h261_play.obj $(TCL_LIB:.tcl=.obj)

SBR_H261PLAY = $(OBJ_H261PLAY:.obj=.sbr)

OBJ_JPEGPLAY = $(OBJ0) jpeg_play.obj jpeg/jpeg.obj \
	renderer.obj renderer-window.obj color.obj \
	$(COLOR_OBJS) \
	Tcl.obj Tcl2.obj vw.obj cm0.obj cm1.obj \
	dct.obj huffcode.obj jpeg_play_tcl.obj bv.obj iohandler.obj timer.obj \
	ui-jpeg_play.obj $(TCL_LIB:.tcl=.obj)

SBR_JPEGPLAY = $(OBJ_JPEGPLAY:.obj=.sbr)

LIB_CB = 
OBJ_CB = $(OBJ0) cbAppInit.obj cb.obj confbus.obj group-ipc.obj iohandler.obj \
	net.obj net-ip.obj crypt.obj crypt-des.obj communicator.obj \
	ppm.obj Tcl.obj Tcl2.obj inet.obj md5c.obj

SBR_CB = $(OBJ_CB:.obj=.sbr)

OBJ_H261DUMP = $(OBJ0) h261_dump.obj p64.obj p64dump.obj huffcode.obj dct.obj bv.obj

SBR_H261DUMP = $(OBJ_H261DUMP:.obj=.sbr)

vic: vic.exe vic.bsc

vic.exe:	$(OBJ) $(OBJ_GRABBER)
	$(link) $(ldebug) $(guilflags) -out:$@ $(OBJ) $(OBJ_GRABBER) $(LIBS)

vic.bsc : $(OUTDIR)  $(SBR)
    $(BSC32) @<<
  $(BSC32_FLAGS) /o$@ $(SBR)
<<

histtolut: histtolut.exe

histtolut.exe: histtolut.obj convex_hull.obj getopt.obj
	$(cc) /nologo -o $@ $(CFLAGS) histtolut.obj convex_hull.obj getopt.obj

vdd: vdd.exe vdd.bsc

vdd.exe: $(OBJ_VDD)
	$(cc) /nologo -o $@ $(CFLAGS) $(LDFLAGS) $(OBJ_VDD) $(LIBS)

vdd.bsc : $(OUTDIR)  $(SBR_VDD)
    $(BSC32) @<<
  $(BSC32_FLAGS) /o$@ $(SBR_VDD)
<<

cb_wish: cb_wish.exe cb_wish.bsc

cb_wish.exe: $(OBJ_CB)
	$(cc) /nologo -o $@ $(CFLAGS) $(LDFLAGS) $(OBJ_CB) $(LIB_CB)

cb_wish.bsc : $(OUTDIR)  $(SBR_CB)
    $(BSC32) @<<
  $(BSC32_FLAGS) /o$@ $(SBR_CB)
<<

jpeg_play: jpeg_play.exe jpeg_play.bsc

jpeg_play.exe: $(OBJ_JPEGPLAY)
	$(cc) /nologo $(CFLAGS) $(LDFLAGS) -o $@ $(OBJ_JPEGPLAY) $(LIBS)

jpeg_play.bsc : $(OUTDIR)  $(SBR_JPEGPLAY)
    $(BSC32) @<<
  $(BSC32_FLAGS) /o$@ $(SBR_JPEGPLAY)
<<

h261_play: h261_play.exe h261_play.bsc

h261_play.exe: $(OBJ_H261PLAY)
	$(link) $(ldebug) $(guilflags) -out:$@ $(OBJ_H261PLAY) $(LIBS)

h261_play.bsc : $(OUTDIR)  $(SBR_H261PLAY)
    $(BSC32) @<<
  $(BSC32_FLAGS) /o$@ $(SBR_H261PLAY)
<<

h261_dump: h261_dump.exe h261_dump.bsc

h261_dump.exe: $(OBJ_H261DUMP)
	$(cc) /nologo -o $@ $(CFLAGS) $(OBJ_H261DUMP)

h261_dump.bsc : $(OUTDIR)  $(SBR_H261DUMP)
    $(BSC32) @<<
  $(BSC32_FLAGS) /o$@ $(SBR_H261DUMP)
<<

h261tortp.exe: h261tortp.cc
	$(cc) /nologo -o $@ $(CFLAGS) h261tortp.cc

#
# pass-1 embedded tcl files
#
$(TCL_LIB:.tcl=.obj): tcl2c++.exe
	-del $@
	.\tcl2c++ 1 $(@:.obj=).tcl > $(@:.obj=).cc
	$(cc) $(cdebug) $(cflags) $(cvars) -o $@ -c $(CFLAGS) -FR$*.sbr -Tp $(@:.obj=).cc
	del $(@:.obj=).cc

tk.obj: tk.tcl

tk.tcl: $(TK_LIBRARY_FILES)
	cat $(TK_LIBRARY_FILES) | sed '/^[ 	]*source[ 	]/d' > tk.tcl

#
# pass-2 embedded tcl files
#
$(TCL_VIC:.tcl=.obj) ui-vdd.obj ui-h261_play.obj: tcl2c++.exe
	-del $@
	.\tcl2c++ 2 $(@:.obj=).tcl > $(@:.obj=).cc
	$(cc) $(cdebug) $(cflags) $(cvars) -o $@ -c $(CFLAGS) -FR$*.sbr -Tp $(@:.obj=).cc
	del $(@:.obj=).cc

ui-ctrlmenu.obj: ui-ctrlmenu.tcl
ui-extout.obj: ui-extout.tcl
ui-grabber.obj: ui-grabber.tcl
ui-main.obj: ui-main.tcl
ui-resource.obj: ui-resource.tcl
ui-srclist.obj: ui-srclist.tcl
ui-stats.obj: ui-stats.tcl
ui-switcher.obj: ui-switcher.tcl
ui-util.obj: ui-util.tcl
ui-windows.obj: ui-windows.tcl
ui-win32.obj: ui-win32.tcl
cf-main.obj: cf-main.tcl
cf-util.obj: cf-util.tcl
cf-network.obj: cf-network.tcl
cf-tm.obj: cf-tm.tcl
cf-confbus.obj: cf-confbus.tcl
tkerror.obj: tkerror.tcl
entry.obj: entry.tcl
ui-vdd.obj: ui-vdd.tcl
ui-h261_play.obj: ui-h261_play.tcl

version.c: VERSION
	-del version.c
	cat VERSION | sed 's/.*/char version[] = "&";/' > version.c

cm0.obj: cm0.c
cm0.c: rgb-cube.ppm jv-cube-128.ppm ppmtolut.exe
	-del $@
	.\ppmtolut -n cube rgb-cube.ppm >> $@
	.\ppmtolut -n jv_cube jv-cube-128.ppm >> $@

cm1.obj: cm1.c
cm1.c: yuv-map.ppm cm170.ppm ppmtolut.exe
	-del $@
	.\ppmtolut -n quant cm170.ppm >> $@
	.\ppmtolut -Y $(ED_YBITS) -n ed -e yuv-map.ppm >> $@

mkhuff.obj: p64/mkhuff.cc
	$(cc) $(cdebug) $(cflags) $(cvars) $(CFLAGS) -o $@ -FR$*.sbr -Tp p64/mkhuff.cc

mkhuff.exe: mkhuff.obj getopt.obj
	-del $@
	$(cc) /nologo -o $@ $(CFLAGS) mkhuff.obj getopt.obj

huffcode.c: mkhuff.exe
	-del $@
	.\mkhuff -e > huffcode.c

mkbv.exe: mkbv.obj
	-del $@
	$(cc) /nologo -o $@ $(CFLAGS) $*.obj

bv.c: mkbv.exe
	-del $@
	.\mkbv > $@

rgb-cube.ppm: mkcube.exe
	.\mkcube rgb > $@

yuv-map.ppm: mkcube.exe
	.\mkcube -Y $(ED_YBITS) -U 45 -V 45 yuv > $@

mkcube.exe: mkcube.obj getopt.obj
	$(cc) /nologo -o $@ $(CFLAGS) mkcube.obj getopt.obj

ppmtolut.exe: ppmtolut.obj getopt.obj
	$(cc) /nologo -o $@ $(CFLAGS) ppmtolut.obj getopt.obj

ppmtolut.obj: ppmtolut.c
	$(cc) $(cflags) $(cvars) $(CFLAGS) -o $@ -FRppmtolut.sbr ppmtolut.c

p64.obj: p64/p64.cc
	$(cc) $(cdebug) $(cflags) $(cvars) $(CFLAGS) -o $@ -FR$*.sbr -Tp p64/p64.cc

p64dump.obj: p64/p64dump.cc
	$(cc) $(cdebug) $(cflags) $(cvars) $(CFLAGS) -o $@ -FR$*.sbr -Tp p64/p64dump.cc

jpeg.obj: jpeg/jpeg.cc
	$(cc) $(cdebug) $(cflags) $(cvars) $(CFLAGS) -o $@ -FR$*.sbr -Tp jpeg/jpeg.cc

install: vic.exe
	install -c vic.exe /usr/local/bin/vic.exe
	install -c histtolut.exe /usr/local/bin/histtolut.exe
	install -c vic.1 /usr/man/manl/vic.l

clean:
	-del *.obj
	-del jpeg\*.obj
	-del p64\*.obj
	-del tcl2c++.exe
	-del mkbv.exe
	-del bv.c
	-del *.sbr
	-del jpeg\*.sbr
	-del p64\*.sbr
	-del mkhuff.exe
	-del huffcode.c
	-del vic_tcl.c
	-del h261_play_tcl.c
	-del tmp.c
	-del vic.exe
	-del h261_play.exe
	-del h261_dump.exe
	-del jpeg_play.exe
	-del cb_wish.exe
	-del mkcube.exe
	-del rgb-cube.ppm
	-del yuv-map.ppm
	-del cm0.c
	-del cm1.c
	-del ppmtolut.exe
	-del config.cache
	-del config.log
	-del domake.*
	-del dotar.*

realclean:
	$(MAKE) clean
	-del config.status

tags:	force
	ctags -tdwC $(SRC) *.h $(TKSRC)/*.c $(TKSRC)/*.h \
		$(TCLSRC)/*.c $(TCLSRC)/*.h

force:

depend:
	$(MKDEP) $(INCLUDES) $(DEFINE) $(SRC)

tar:	force
	tar=vicbin-`cat VERSION`-@V_TAR_TARGET@.tar.gz ; \
	rm -f $$tar ; \
	@V_TARCMD@ - README CHANGES.html vic.1 @V_TAR_EXTRA@ $(ALL) | \
		gzip -c > $$tar

srctar: force
	@cwd=`pwd` ; dir=`basename $$cwd` ; \
	    name=vic-`cat VERSION | tr A-Z a-z` ; \
	    tar=vicsrc-`cat VERSION`.tar.gz ; \
	    list="" ; \
	    for i in `cat FILES` ; do list="$$list $$name/$$i" ; done; \
	    echo \
	    "(rm -f $$tar; cd .. ; ln -s $$dir $$name)" ; \
	     (rm -f $$tar; cd .. ; ln -s $$dir $$name) ; \
	    echo \
	    "(cd .. ; tar cfh $$tar [lots of files])" ; \
	     (cd .. ; tar cfh - $$list) | gzip -c > $$tar ; \
	    echo \
	    "rm ../$$name; chmod 444 $$tar" ;  \
	     rm ../$$name; chmod 444 $$tar

fulltar: force
	@cwd=`pwd` ; dir=`basename $$cwd` ; \
	    name=vic-`cat VERSION | tr A-Z a-z` ; \
	    list="" ; \
	    for i in `cat FILES FILES.EXTRA` ; \
		do list="$$list $$name/$$i" ; done; \
	    echo \
	    "(cd .. ; rm -f $$name; ln -s $$dir $$name)" ; \
	     (cd .. ; rm -f $$name; ln -s $$dir $$name) ; \
	    echo \
	    "(cd .. ; tar cfh $$dir/$$name.tar [lots of files])" ; \
	     (cd .. ; tar cfh $$dir/$$name.tar $$list) ; \
	    echo \
	    "rm -f $$name.tar.gz ../$$name" ; \
	     rm -f $$name.tar.gz ../$$name  ; \
	    echo \
	    "gzip $$name.tar" ; \
	     gzip $$name.tar ; \
	    echo \
	    "chmod 444 $$name.tar.gz" ; \
	     chmod 444 $$name.tar.gz

